%define _tmpdir %{_topdir}/tmp
Summary: A collection of tools for managing UNIX services.
Name: daemontools
Version: 0.76
Release: 5
License: See djb@pobox.com
Group: Utilities/System
Source0: http://pobox.com/~djb/daemontools/daemontools-%{version}.tar.gz
Source1: http://smarden.org/pape/djb/manpages/daemontools-0.76-man.tar.gz
Source2: svscan.init
Source3: daemontools.conf
Source4: daemontoolsboot
Patch0: errno.patch
BuildRoot: %{_tmpdir}/daemontools
URL: http://pobox.com/~djb/daemontools.html
Packager: David Summers <david@summersoft.fay.ar.us>
ExclusiveOS: linux solaris2.9

%description
daemontools is a collection of tools for managing UNIX services. 

supervise monitors a service. It starts the service and restarts the
service if it dies. Setting up a new service is easy: all supervise
needs is a directory with a run script that runs the service.

multilog saves error messages to one or more logs. It optionally
timestamps each line and, for each log, includes or excludes lines
matching specified patterns. It automatically rotates logs to limit the
amount of disk space used. If the disk fills up, it pauses and tries
again, without losing any data.

%changelog
* Tue Jul 19 2011 David Summers <david@summersoft.fay.ar.us> 0.76-5
- Fixed RHEL6/CentOS6 startup of svscan.
- Took out /bin/svscanboot - We don't use it and it generates bad code anyway.

* Sun Jul 17 2011 David Summers <david@summersoft.fay.ar.us> 0.76-4
- Updated for CentOS 6 (upstart).

* Sat Oct 18 2003 David Summers <david@summersoft.fay.ar.us> 0.76-3
- Compiles on Solaris 2.9.
- Remember to clean up after we build.
- Fixed spec file: Changed Copyright tag to License for RHEL5.

* Wed Sep 03 2003 David Summers <david@summersoft.fay.ar.us> 0.76-2
- Fixed Redhat 9 compile problem with "errno" variable.

%prep
%setup -n admin -q -a 1

# Fix "errno" compile problem with Redhat 9.
%patch0 -p1

%build
cd daemontools-0.76
./package/compile

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
mkdir -p $RPM_BUILD_ROOT/service

(
cd daemontools-0.76
cp command/* $RPM_BUILD_ROOT/bin
)

# Install man pages
cp daemontools-man/README README.man
cp daemontools-man/*.8 $RPM_BUILD_ROOT/usr/share/man/man8

# Copy upstart config file
mkdir -p $RPM_BUILD_ROOT/etc/init
cp %{SOURCE3} $RPM_BUILD_ROOT/etc/init

mkdir -p $RPM_BUILD_ROOT/sbin
cp %{SOURCE4} $RPM_BUILD_ROOT/sbin
chmod a+x $RPM_BUILD_ROOT/sbin/*

# Cleanup
# Take out /sbin/svscanboot - It generates error code and we don't use it anyway.
rm -rf $RPM_BUILD_ROOT/bin/svscanboot

%post
echo "SV:123456:respawn:env - PATH=/usr/local/bin:/usr/sbin:/usr/bin:/bin svscan /service < /dev/null > /dev/console 2> /dev/console" >> /etc/inittab

%preun
sed -e '/^SV:/d' < /etc/inittab > /etc/inittab.new && mv /etc/inittab /etc/inittab.old && mv /etc/inittab.new /etc/inittab
kill -HUP 1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc daemontools-0.76/src/CHANGES README.man daemontools-0.76/src/TODO
%dir /service
/etc/init/*
/bin/*
/sbin/*
/usr/share/man/man8
